/**
    An interface for a pile of books.
    @author Frank M. Carrano
    @version 3.0
*/
public interface PileInterface
{
  /** Adds a new book to the top of this pile.
      @param newBook  an object to be added to the pile */
  public void add(String newBook);
  
  /** Removes and returns this piles top book.
      @return either the book at the top of the pile or, if the
              pile is empty before the operation, null */
  public String remove();
  
  /** Retrieves this piles top book.
      @return either the book at the top of the pile or null if
              the pile is empty */
  public String getTopBook();
  
  /** Detects whether this pile is empty.
      @return true if the pile is empty */
  public boolean isEmpty();
  
  /** Removes all books from this pile */
  public void clear();
} // end PileInterface
