
/**
   An interface for the ADT Shoe. A shoe consists of
   some number of decks of standard playing cards.
   
   @author Frank M. Carrano
   @version 3.0
*/
public interface ShoeInterface
{
    /**
       Deals a card from this shoe.
       @return the card that was dealt */
    public PlayingCard dealCard();
    
    /**
       Puts a card in this shoe.
       @param aCard  the card to be returned to the shoe */
    public void returnCard(PlayingCard aCard);
    
    /**
       Shuffles all the cards remaining in this shoe. */
    public void shuffle();
    
    /**
       Resets this shoe by returning all cards to it. */
    public void reset();
} // end ShoeInterface
