/**
   A driver that demonstrates the class Ring.
   @author Frank M. Carrano
   @version 3.0
*/
public class Project4 
{
	public static void main(String[] args) 
	{
		System.out.println("Create a ring");
		RingInterface<String> myRing = new Ring<String>(5);
		System.out.println("isEmpty() returns " + myRing.isEmpty() + "\n");
		
		System.out.println("Add to ring.\n");
		myRing.add("Golden");
		myRing.add("Circle");
		myRing.add("Bell");
		myRing.add("Phone");
		myRing.add("Corral");
      
      myRing.advance();

		System.out.println("isEmpty() returns " + myRing.isEmpty() + "\n");
		System.out.println("The ring contains " + myRing.getLength() + " entries\n");

		System.out.println("Testing getCurrentEntry and advance:\n");
		for (int counter = 0; counter < myRing.getLength() + 2; counter++)
		{
			String current = myRing.getCurrentEntry();
			System.out.println(current + " is current entry.");
			myRing.advance();
		} // end while

		System.out.println("\nTesting remove:\n");
		while (!myRing.isEmpty())
			System.out.println(myRing.remove() + " is removed from the ring.\n");

		System.out.println("The ring should be empty: ");
		System.out.println("isEmpty() returns " + myRing.isEmpty() + "\n\n");

		System.out.println("Add to the ring.");
		myRing.add("Round");
		myRing.add("Bathtub");
		myRing.add("Hoop");
		
		System.out.println("\nTesting clear:\n");
		myRing.clear();
			
		System.out.print("The ring should be empty: ");
		System.out.println("isEmpty() returns " + myRing.isEmpty() + "\n\n");

		System.out.println("myRing.getCurrentEntry() returns " +  myRing.getCurrentEntry());
		System.out.println("myRing.remove()  returns " +  myRing.remove() + "\n");
		System.out.println("\nDone.");
	}  // end main
}  // end Project4

/*
//INITIAL SIZE IS 5:
Create a ring
isEmpty() returns true

Add to ring.

isEmpty() returns false

The ring contains 5 entries

Testing getCurrentEntry and advance:

Circle is current entry.
Bell is current entry.
Phone is current entry.
Corral is current entry.
Golden is current entry.
Circle is current entry.
Bell is current entry.

Testing remove:

Golden is removed from the ring.

Circle is removed from the ring.

Bell is removed from the ring.

Phone is removed from the ring.

Corral is removed from the ring.

The ring should be empty: 
isEmpty() returns true


Add to the ring.

Testing clear:

The ring should be empty: isEmpty() returns true


myRing.getCurrentEntry() returns null
myRing.remove()  returns null


Done.

//INITAL SIZE IS 3
Create a ring
isEmpty() returns true

Add to ring.

isEmpty() returns false

The ring contains 5 entries

Testing getCurrentEntry and advance:

Circle is current entry.
Bell is current entry.
Phone is current entry.
Corral is current entry.
Golden is current entry.
Circle is current entry.
Bell is current entry.

Testing remove:

Golden is removed from the ring.

Circle is removed from the ring.

Bell is removed from the ring.

Phone is removed from the ring.

Corral is removed from the ring.

The ring should be empty: 
isEmpty() returns true


Add to the ring.

Testing clear:

The ring should be empty: isEmpty() returns true


myRing.getCurrentEntry() returns null
myRing.remove()  returns null


Done.

*/