import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
/** Chapter 2, Project5.
    @author Frank M. Carrano
    @version 3.0
*/
public class Project6
{
	public static void main(String[] args) 
	{
      TextFileOperations.createTextFile("dictionary", 10);
		TextFileOperations.createTextFile("document", 5);
      
      // read document; create a bag of its words and check their spelling 
      BagInterface<String> wordBag = new ResizableArrayBag<String>();
      try
      {
         Scanner fileData = new Scanner(new File("document"));
         while (fileData.hasNextLine())
         {
            String word = fileData.nextLine();
            wordBag.add(word);
         } // end while
         
         fileData.close();
      }
      catch (FileNotFoundException e)
      {
         System.out.println("Error opening document.");
      }
      
      SpellChecker checker = new SpellChecker();
      checker.setDictionary(new File("dictionary"));
      BagInterface<String> incorrectWords = checker.checkSpelling(wordBag);
      System.out.println("The incorrectly spelled words are");
      displayBag(incorrectWords);
	} // end main
   
   // Displays a bag.
	private static void displayBag(BagInterface<String> aBag)
	{
		Object[] bagArray = aBag.toArray();
		for (int index = 0; index < bagArray.length; index++)
		{
			System.out.print(bagArray[index] + " ");
		} // end for
		
		System.out.println();
	} // end displayBag

} // end Project6
/*
Enter 10 lines of data:
Line 1: able
Line 2: baker
Line 3: gamma
Line 4: delta
Line 5: epsilon
Line 6: red
Line 7: blue
Line 8: green
Line 9: yellow
Line 10: white
Enter 5 lines of data:
Line 1: gama
Line 2: blue
Line 3: dalta
Line 4: yallow
Line 5: white
The incorrectly spelled words are
gama yallow dalta 
*/